import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrClassroomquestionpackage {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  Name?: string;
  BookId!: IType<number, bigint>;
  ClassRoomCourseId!: IType<number, bigint>;
  Type!: number;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrClassroomquestionpackageSchema = defineEntity({
  class: IcrClassroomquestionpackage,
  comment: '课堂问题包',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    Name: p.string().name('Name').nullable().comment('问题包名称'),
    BookId: p.bigint().name('BookId').columnType('bigint').comment('书籍Id'),
    ClassRoomCourseId: p.bigint().name('ClassRoomCourseId').columnType('bigint').comment('课程Id'),
    Type: p.integer().name('Type').comment('问题包类型'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
